package com.capgemini.reports.snecmaobjects.part;

import com.capgemini.framework.teamcenter.authent.TcSession;
import com.capgemini.framework.teamcenter.object.types.SnecmaObjectTypes;
import com.capgemini.reports.snecmaobjects.visitor.IComponentVisitor;
import com.capgemini.reports.snecmaobjects.visitor.IReceptorVisitor;
import com.teamcenter.soa.client.model.strong.ItemRevision;

import static com.capgemini.framework.teamcenter.object.SnecmaObjectProperties.PV_CLASSEMENT_MATIERE;
import static com.capgemini.framework.teamcenter.object.SnecmaObjectProperties.PV_FOURNISSEURS;

/**
 * Class representing a PartMatRevision.
 */
public class PartMatRevision extends AbstractPart {
    private static final long serialVersionUID = -3225565405583804909L;

    public PartMatRevision(final TcSession session, final ItemRevision itemRevision) {
        super(session, itemRevision);
    }

    public String getClassementMat() {
        return getMasterFormRev().getPropertyObject(PV_CLASSEMENT_MATIERE).getStringValue();
    }

    public String[] getLstFournisseurs() {
        return itemRevision.getPropertyObject(PV_FOURNISSEURS).getStringArrayValue();
    }

    @Override
    public <T> T accept(final IReceptorVisitor<T> aReceptorVisitor) {
        return aReceptorVisitor.visitReceptor(this);
    }

    @Override
    public <T> T accept(final IComponentVisitor<T> aComponentVisitor) {
        return aComponentVisitor.visitComponent(this);
    }

    @Override
    public boolean isSuperModel() {
        return false;
    }

    @Override
    public String toString() {
        return SnecmaObjectTypes.PART_MAT_REVISION + " " + this.getItemId();
    }
}
